//------------------------------------------------------------------------------
// luagݍł݂ 0.0.11
//------------------------------------------------------------------------------
/*
MinGW(gcc 4.5.0)ŃRpCmF
*/
#include <windows.h>
#include <shlwapi.h>
#include <string.h>
#include <tchar.h>
#include "filter.h"

extern "C" {
#include "lua.h"
#include "lualib.h"
#include "lauxlib.h"
}

#define NOINLINE __declspec(noinline)

//---------------------------------------------------------------------
// O[oϐƂ
//---------------------------------------------------------------------
#define ID_BROWSE  1100
#define ID_RELOAD  1101
#define ID_FREE    1102
#define ID_EDITBOX 1103

static lua_State *Lua = NULL;
HWND hedit = NULL;
static char filter_name[FILENAME_MAX+1] = "lua4aviutl"; // vOC̖O
static HINSTANCE dll_hinst = NULL;
static BOOL lite_mode = FALSE;
static FILTER           *global_fp = NULL;
static FILTER_PROC_INFO *global_fpip = NULL;
static void             *global_editp = NULL;
static char              global_current_backup[MAX_PATH];
static unsigned short    global_cw_backup;

extern BOOL init_lua();
extern void free_lua();
extern BOOL lock_lua(FILTER *fp, FILTER_PROC_INFO *fpip, void *editp);
extern BOOL unlock_lua();
extern void print_edit(const char *str);
extern void show_error(lua_State* L);

extern int call_message(lua_State* L);
extern int call_get_filter_name(lua_State* L);
extern int call_is_lite_mode(lua_State* L);

extern int call_is_edting(lua_State* L);
extern int call_is_saving(lua_State* L);
extern int call_is_saveframe(lua_State* L);
extern int call_is_keyframe_input(lua_State* L);
extern int call_is_editflag_keyframe(lua_State* L);
extern int call_is_editflag_markframe(lua_State* L);
extern int call_is_editflag_delframe(lua_State* L);
extern int call_get_w(lua_State* L);
extern int call_get_h(lua_State* L);
extern int call_get_max_w(lua_State* L);
extern int call_get_max_h(lua_State* L);
extern int call_get_min_w(lua_State* L);
extern int call_get_min_h(lua_State* L);
extern int call_get_size(lua_State* L);
extern int call_set_w(lua_State* L);
extern int call_set_h(lua_State* L);
extern int call_set_size(lua_State* L);
extern int call_get_ycp_edit(lua_State* L);
extern int call_get_ycp_temp(lua_State* L);
extern int call_swap(lua_State* L);
extern int call_get_frame(lua_State* L);
extern int call_get_frame_n(lua_State* L);
extern int call_get_org_w(lua_State* L);
extern int call_get_org_h(lua_State* L);
extern int call_get_org_size(lua_State* L);
extern int call_set_frame_n(lua_State* L);
extern int call_resize_yc(lua_State* L);
extern int call_copy_yc(lua_State* L);
extern int call_draw_text(lua_State* L);
extern int call_rgb2yc(lua_State* L);
extern int call_yc2rgb(lua_State* L);
extern int call_get_track(lua_State* L);
extern int call_get_check(lua_State* L);
extern int call_set_ycp_filtering_cache_size(lua_State* L);
extern int call_get_ycp_filtering_cache_ex(lua_State* L);
extern int call_create_yc(lua_State* L);
extern int call_delete_yc(lua_State* L);
extern int call_get_select_frame(lua_State* L);
extern int call_set_select_frame(lua_State* L);
extern int call_load_image(lua_State* L);
extern int call_get_pixel_yc(lua_State* L);
extern int call_set_pixel_yc(lua_State* L);
extern int call_box(lua_State* L);
extern int call_invert(lua_State* L);
extern int call_monochroma(lua_State* L);
extern int call_mosaic(lua_State* L);
extern int call_line(lua_State* L);
extern int call_flip_vertical(lua_State* L);
extern int call_flip_horizontal(lua_State* L);
extern int aviutl_gdoverlay(lua_State* L);

extern int call_AND(lua_State* L);
extern int call_OR(lua_State* L);
extern int call_XOR(lua_State* L);
extern int call_SHIFT(lua_State* L);
extern int call_BIT(lua_State* L);

static const luaL_Reg aufLib[] = {
    {"message",             call_message},
    {"text",                call_message},
    {"get_filter_name",     call_get_filter_name},
    {"is_lite_mode",        call_is_lite_mode},
    {NULL, NULL}
};

static const luaL_Reg aviutlLib[] = {
    {"is_edting",       call_is_edting},
    {"is_saving",       call_is_saving},
    {"is_saveframe",    call_is_saveframe},
    {"is_keyframe_input",       call_is_keyframe_input},
    {"is_keyframe",             call_is_editflag_keyframe},
    {"is_editflag_keyframe",    call_is_editflag_keyframe},
    {"is_editflag_markframe",   call_is_editflag_markframe},
    {"is_editflag_delframe",    call_is_editflag_delframe},
    {"get_frame",       call_get_frame},
    {"get_frame_n",     call_get_frame_n},
    {"set_frame_n",     call_set_frame_n},
    {"get_w",           call_get_w},
    {"get_h",           call_get_h},
    {"get_max_w",       call_get_max_w},
    {"get_max_h",       call_get_max_h},
    {"get_min_w",       call_get_min_w},
    {"get_min_h",       call_get_min_h},
    {"get_size",        call_get_size},
    {"set_w",           call_set_w},
    {"set_h",           call_set_h},
    {"set_size",        call_set_size},
    {"get_org_w",       call_get_org_w},
    {"get_org_h",       call_get_org_h},
    {"get_org_size",    call_get_org_size},
    {"get_ycp_edit",    call_get_ycp_edit},
    {"get_ycp_temp",    call_get_ycp_temp},
    {"swap",            call_swap},
    {"resize",          call_resize_yc},
    {"copy",            call_copy_yc},
    {"draw_text",       call_draw_text},
    {"rgb2yc",          call_rgb2yc},
    {"yc2rgb",          call_yc2rgb},
    {"get_track",       call_get_track},
    {"get_check",       call_get_check},
    {"get_ycp_filtering_cache_ex",      call_get_ycp_filtering_cache_ex},
    {"set_ycp_filtering_cache_size",    call_set_ycp_filtering_cache_size},
    {"create",          call_create_yc},
    {"delete",          call_delete_yc},
    {"load_image",      call_load_image},
    {"get_select_frame",    call_get_select_frame},
    {"set_select_frame",    call_set_select_frame},
    {"get_pixel",       call_get_pixel_yc},
    {"set_pixel",       call_set_pixel_yc},
    {"box",             call_box},
    {"invert",          call_invert},
    {"monochroma",      call_monochroma},
    {"mosaic",          call_mosaic},
    {"line",            call_line},
    {"flip_vertical",   call_flip_vertical},
    {"flipV",           call_flip_vertical},
    {"flip_horizontal", call_flip_horizontal},
    {"flipH",           call_flip_horizontal},
    {"gdoverlay",       aviutl_gdoverlay},
    {NULL, NULL}
};

//---------------------------------------------------------------------
// O֐ɂ
//---------------------------------------------------------------------
extern void my_box(PIXEL_YC *ycp, int left, int top, int width, int height, int Y, int Cb, int Cr, int tr, int max_w, int max_h);
extern void my_invert(PIXEL_YC *ycp, int left, int top, int width, int height, int max_w, int max_h);
extern void my_monochroma(PIXEL_YC *ycp, int left, int top, int width, int height, int Cb, int Cr, int max_w, int max_h);
extern void my_line(PIXEL_YC *ycp, int x1, int y1, int x2, int y2, int Y, int Cb, int Cr, int tr, int max_w, int max_h, BOOL skipfirst);
extern void my_flip_vertical(PIXEL_YC *ycp, int left, int top, int width, int height, int max_w, int max_h);
extern void my_flip_horizontal(PIXEL_YC *ycp, int left, int top, int width, int height, int max_w, int max_h);
extern void my_mosaic( PIXEL_YC *ycp, int left, int top, int width, int height, int bw, int bh, int max_w, int max_h, BOOL strict );

//---------------------------------------------------------------------
// tB^\̒`
//---------------------------------------------------------------------
#define TRACK_N 9
TCHAR *track_name[]     = {(TCHAR *)"track0", (TCHAR *)"track1", (TCHAR *)"track2", (TCHAR *)"track3", (TCHAR *)"track4", (TCHAR *)"track5", (TCHAR *)"track6", (TCHAR *)"track7", (TCHAR *)"track8"};
int     track_default[] = {0, 0, 0, 0, 0, 0, 0, 0, 0};
int     track_s[]       = {-4096, -4096, -4096, -4096, -4096, -4096, -4096, -4096, -4096};
int     track_e[]       = { 4096,  4096,  4096,  4096,  4096,  4096,  4096,  4096,  4096};

#define CHECK_N 4
TCHAR *check_name[] = {(TCHAR *)"check0", (TCHAR *)"check1", (TCHAR *)"check2", (TCHAR *)"check3"};
int check_default[] = {0, 0, 0, 0};

#define WIN_ADD (24*(TRACK_N+1)+16*(CHECK_N+1))

// gf[^ɃXNvg̃pXۑ̂ł̃TCY
// gҏWvOCg悤ɂ邽߂ɂ1000oCgȉɂ
#define SCRIPT_PATH 1000
char ex_data[SCRIPT_PATH]; // gf[^

FILTER_DLL filter = {
    FILTER_FLAG_EX_INFORMATION | FILTER_FLAG_EX_DATA | FILTER_FLAG_WINDOW_SIZE,
    320, 120+WIN_ADD,
    (TCHAR *)filter_name,
    TRACK_N,
    track_name,
    track_default,
    track_s,track_e,
    CHECK_N,
    check_name,
    check_default,
    func_proc,
    func_init,
    func_exit,
    NULL,
    func_WndProc,
    NULL,NULL,
    ex_data, // XNvg̃pXgf[^Ƃĕۑ
    sizeof(ex_data), // gf[^̃TCY
    (TCHAR *)"lua for aviutl ver0.0.11 by ۂgocha",
    NULL,
    NULL,
};

//---------------------------------------------------------------------
// DLLMain
// ʏ̃tB^Ȃ炢ȂAHINSTANCE擾邽߂ɗp
//---------------------------------------------------------------------
EXTERN_C WINAPI __declspec(dllexport) BOOL __stdcall DllMain(HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpvReserved)
{
    dll_hinst = hinstDLL;
    return TRUE;
}

//---------------------------------------------------------------------
// tB^\̂̃|C^n֐
//---------------------------------------------------------------------
EXTERN_C FILTER_DLL __declspec(dllexport) * __stdcall GetFilterTable( void )
{
    char filename[FILENAME_MAX];
    char str[SCRIPT_PATH + sizeof(filter_name) + sizeof(filename)]; // 傫߂Ɋm

    // DLL̃x[Xt@C擾
    GetModuleFileName(dll_hinst, str, sizeof(str));
    _splitpath(str, NULL, NULL, filename, NULL);
    // ftHg̖OƈtB^[ύX
    if (strcmp(filename, "lua4aviutl")) {
        strncpy(filter_name, filename, sizeof(filter_name));
        filter_name[sizeof(filter_name)-1] = '\0';
        filter.name = (TCHAR *)filter_name;

        // tB^[̖ "_lite" Ȃ烉Cg[hɂ
        int len = strlen(filter_name) - strlen("_lite");
        if (len >= 0 && strcmp(filter_name+len, "_lite") == 0) {
            filter.x = 320;
            filter.y = 120;
            filter.track_n = 0;
            filter.check_n = 0;
            lite_mode = TRUE;
        }
    }

    return &filter;
}

//---------------------------------------------------------------------
// HWNDŎw肳ꂽݒEChẼ^CgAbvf[g
//---------------------------------------------------------------------
NOINLINE void update_window_title(HWND hwnd, const char *script)
{
    if ( !hwnd || !script ) return;

    char filename[FILENAME_MAX];
    char str[SCRIPT_PATH + sizeof(filter_name) + sizeof(filename)]; // 傫߂Ɋm

    if (GetFileTitle(script, filename, sizeof(filename))) filename[0] = '\0';
    sprintf(str, "%s:%s", filter_name, filename);
    SetWindowText(hwnd, (LPCTSTR)str);
}

//---------------------------------------------------------------------
// JnɌĂ΂֐
//---------------------------------------------------------------------
BOOL func_init(FILTER *fp)
{
    return TRUE;
}

//---------------------------------------------------------------------
// IɌĂ΂֐
//---------------------------------------------------------------------
BOOL func_exit(FILTER *fp)
{
    lock_lua(fp, NULL, NULL);
    free_lua();
    unlock_lua();
    return TRUE;
}

//---------------------------------------------------------------------
// tB^֐
//---------------------------------------------------------------------
BOOL func_proc(FILTER *fp, FILTER_PROC_INFO *fpip)
{
    lock_lua(fp, fpip, fpip->editp);

    char *script = (char *)fp->ex_data_ptr;

    // gҏWŎgpꍇ́Aŏ͂
    if (!Lua && script[0] != '\0') {
        print_edit("Script Load in func_proc()");
        init_lua();
    }

    if (Lua) {
        lua_settop(Lua, 0); // X^bN̈ʒuC
        // s
        lua_getglobal(Lua, "func_proc");
        if ( lua_pcall(Lua, 0, 0, 0) ) {
            show_error(Lua);
            //free_lua();
        }
    }

    unlock_lua();
    return TRUE;
}

//---------------------------------------------------------------------
// ݒEBhEɃEBhEbZ[WɌĂ΂֐
//---------------------------------------------------------------------
BOOL func_WndProc(HWND hwnd, UINT message, WPARAM wparam, LPARAM lparam, void *editp, FILTER *fp)

{
    char str[SCRIPT_PATH + 4096]; // 傫߂Ɋm
    char *script = (char *)fp->ex_data_ptr; // XNvg̃pX

    switch(message){
        case WM_COMMAND:
            switch(LOWORD(wparam)) {
                case ID_BROWSE:
                {
                    // XNvgǂݍ
                    if (fp->exfunc->dlg_get_load_name(str, (LPSTR)"luaXNvg(*.lua)\0*.lua\0ׂẴt@C(*.*)\0*.*\0", script) ) {
                        strncpy(script, str, SCRIPT_PATH);
                        script[SCRIPT_PATH-1] = '\0';

                        print_edit("Script Load");

                        lock_lua(fp, NULL, editp);
                        free_lua();
                        init_lua();
                        unlock_lua();

                        update_window_title(hwnd, script);
                        return TRUE;
                    }
                }

                case ID_RELOAD:
                {
                    lock_lua(fp, NULL, editp);
                    free_lua();
                    if (script[0] != '\0') {
                        // ēǂݍ
                        print_edit("Script Reload");
                        init_lua();
                    } else {
                        print_edit("Script Free");
                    }
                    unlock_lua();
                    update_window_title(hwnd, script);
                    return TRUE;
                }

                case ID_FREE:
                {
                    // 
                    script[0] = '\0';
                    print_edit("Script Free");
                    lock_lua(fp, NULL, editp);
                    free_lua();
                    unlock_lua();
                    update_window_title(hwnd, script);
                    return TRUE;
                }

            }
            break;

        case WM_FILTER_CHANGE_ACTIVE: //tB^̗L/ύXꂽ
            // ̓̕vt@Cؑ֎ɌĂ΂Ă炵
            // LȂ烊[hsBȂ
            lock_lua(fp, NULL, editp);
            free_lua();
            if ( fp->exfunc->is_filter_active(fp) && script[0] != '\0' ) {
                print_edit("Script Reload");
                init_lua(); // ēǂݍ
            } else {
                print_edit("Script Free");
            }
            unlock_lua();
            update_window_title(hwnd, script);
            break;

        case WM_FILTER_INIT:
        {

            // {^ނt
            int win_add = lite_mode ? 0 : WIN_ADD;

            HWND button1 = CreateWindow(
                TEXT("BUTTON"),
                "Browse...",
                WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
                4, 4 + win_add,
                64, 20,
                hwnd, (HMENU)ID_BROWSE, fp->dll_hinst, NULL);
            if (button1) SendMessage(button1, WM_SETFONT, (WPARAM)GetStockObject(DEFAULT_GUI_FONT), FALSE);

            HWND button2 = CreateWindow(
                TEXT("BUTTON"),
                "Reload",
                WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
                72, 4 + win_add,
                64, 20,
                hwnd, (HMENU)ID_RELOAD, fp->dll_hinst, NULL);
            if (button2) SendMessage(button2, WM_SETFONT, (WPARAM)GetStockObject(DEFAULT_GUI_FONT), FALSE);

            HWND button3 = CreateWindow(
                TEXT("BUTTON"),
                "Free",
                WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
                140, 4 + win_add,
                64, 20,
                hwnd, (HMENU)ID_FREE, fp->dll_hinst, NULL);
            if (button3) SendMessage(button3, WM_SETFONT, (WPARAM)GetStockObject(DEFAULT_GUI_FONT), FALSE);

            hedit = CreateWindowEx(
                WS_EX_CLIENTEDGE,
                TEXT("EDIT"),
                NULL,
                WS_VISIBLE | WS_CHILD | ES_MULTILINE | ES_AUTOHSCROLL | ES_AUTOVSCROLL | WS_VSCROLL | WS_HSCROLL | ES_READONLY,
                4, 28 + win_add,
                306, 64,
                hwnd, (HMENU)ID_EDITBOX, fp->dll_hinst, NULL);

            if (hedit) SendMessage(hedit, WM_SETFONT, (WPARAM)GetStockObject(DEFAULT_GUI_FONT), FALSE);

            // inipX擾
            fp->exfunc->ini_load_str(fp, (LPSTR)"script_path", str, (LPSTR)"");
            strncpy(script, str, SCRIPT_PATH);
            script[SCRIPT_PATH-1] = '\0';

            // WM_FILTER_CHANGE_ACTIVEłxsĂ܂悤Ȃ̂ňȉRgAEg
            //if (script[0] != '\0') {
            //    print_edit("Script Load in WM_FILTER_INIT");
            //    lock_lua(fp, NULL, editp);
            //    init_lua();
            //    unlock_lua();
            //} else {
            //    print_edit("Script Free");
            //}

            DragAcceptFiles(hwnd, TRUE);

            update_window_title(hwnd, script);
            return TRUE;
        }

        case WM_FILTER_EXIT:
            // iniɃpXۑ
            fp->exfunc->ini_save_str(fp, (LPSTR)"script_path", script);

            DragAcceptFiles(hwnd, FALSE);
            break;

        case WM_DROPFILES: {
            HDROP hDrop = (HDROP)wparam;
            DragQueryFile(hDrop, 0, str, sizeof(str));
            DragFinish(hDrop);

            strncpy(script, str, SCRIPT_PATH);
            script[SCRIPT_PATH-1] = '\0';

            print_edit("Script Load by Drag&Drop");

            lock_lua(fp, NULL, editp);
            free_lua();
            init_lua();
            unlock_lua();

            update_window_title(hwnd, script);
            return FALSE;
        }
    }

    return FALSE;
}

//---------------------------------------------------------------------
// Lua
//---------------------------------------------------------------------
BOOL init_lua()
{
    free_lua(); // Ô

    char *script = global_fp ? (char *)global_fp->ex_data_ptr : NULL;

    // XNvgw肳ĂȂƏI
    if (script == NULL || script[0] == '\0') return FALSE;

    // VLuaXe[g쐬
    Lua = luaL_newstate();
    if (Lua == NULL) return FALSE;

    // WLuaCuǂݍ
    luaL_openlibs(Lua);

    // ֐Qo^
    luaL_register(Lua, "auf", aufLib);
    luaL_register(Lua, "aviutl", aviutlLib);
    lua_register(Lua, "AND", call_AND);
    lua_register(Lua, "OR", call_OR);
    lua_register(Lua, "XOR", call_XOR);
    lua_register(Lua, "SHIFT", call_SHIFT);
    lua_register(Lua, "BIT", call_BIT);

    // t@Cǂݍ݁Aŏ̎s
    if (luaL_loadfile(Lua, script) || lua_pcall(Lua, 0, 0, 0)) {
        show_error(Lua);
        lua_close(Lua);
        Lua = NULL;
        return FALSE;
    }

    return TRUE;
}

//---------------------------------------------------------------------
// LuaJ
//---------------------------------------------------------------------
void free_lua()
{
    if (Lua) {
        // IOfunc_exits
        lua_settop(Lua, 0); // X^bN̈ʒuC
        lua_getglobal(Lua, "func_exit");
        if ( lua_pcall(Lua, 0, 0, 0) ) show_error(Lua);
        lua_close(Lua);
        Lua = NULL;
    }
}

//---------------------------------------------------------------------
// luå֐g悤ɂ
// ֐lockɃbNĂ킯Ȃ
//---------------------------------------------------------------------
NOINLINE BOOL lock_lua(FILTER *fp, FILTER_PROC_INFO *fpip, void *editp)
{
    // p\ȃ|C^O[oϐɃRs[
    global_fp = fp;
    global_fpip = fpip;
    global_editp = editp;

    // ݂̃JgfBNgۑ
    GetCurrentDirectory(sizeof(global_current_backup), global_current_backup);

    // XNvgt@CfBNgJgɂ
    if (fp) {
        char str[SCRIPT_PATH];
        strncpy(str, (char *)fp->ex_data_ptr, sizeof(str));
        str[sizeof(str)-1] = '\0';
        PathRemoveFileSpec(str);
        SetCurrentDirectory(str);
    }

    // ݂FPỦZxۑA53bit(double)ɐݒ
    unsigned short cw;
    __asm__ volatile( "fnstcw %0" : "=m"(cw) );
    global_cw_backup = cw;
    cw = (cw & ~0x300) | 0x200;
    __asm__ volatile( "fldcw %0" :: "m"(cw) );

    return TRUE;
}

//---------------------------------------------------------------------
// luå֐gȂ悤ɂiL֐Ƒ΁j
//---------------------------------------------------------------------
NOINLINE BOOL unlock_lua()
{
    global_fp = NULL;
    global_fpip = NULL;
    global_editp = NULL;

    // FPU̐x𕜋A
    unsigned short cw = global_cw_backup;
    __asm__ volatile( "fldcw %0" :: "m"(cw) );

    SetCurrentDirectory(global_current_backup); // JgfBNgA

    return TRUE;
}

//---------------------------------------------------------------------
// heditɃeLXg\
//---------------------------------------------------------------------
void print_edit(const char *str)
{
    if (hedit) SendMessage(hedit, WM_SETTEXT, 0, (LPARAM)str);
}

//---------------------------------------------------------------------
// LuãG[bZ[W\X^bN|bv
//---------------------------------------------------------------------
void show_error(lua_State* L)
{
    print_edit( lua_tostring(L, -1) );
    lua_pop(L, 1);
}

//---------------------------------------------------------------------
// [auf]heditɃbZ[WieLXgj\
//---------------------------------------------------------------------
int call_message(lua_State* L)
{
    if (lua_isstring(L, 1)) print_edit(lua_tostring(L, 1));
    return 0;
}

//---------------------------------------------------------------------
// [auf]tB^[̖OԂig邩mȂj
// ߂lFtB^[̖Oi.auf́j
//---------------------------------------------------------------------
int call_get_filter_name(lua_State* L)
{
    lua_pushstring(L, filter_name);
    return 1;
}

//---------------------------------------------------------------------
// [auf]Cg[hׂ
// ߂lFCg[hȂtrue
//---------------------------------------------------------------------
int call_is_lite_mode(lua_State* L)
{
    lua_pushboolean(L, !!lite_mode);
    return 1;
}

//---------------------------------------------------------------------
// [aviutl]ݕҏWׂ
// ߂lFҏWȂtrueiׂȂƂnilj
//---------------------------------------------------------------------
int call_is_edting(lua_State* L)
{
    if (global_fp && global_editp) {
        lua_pushboolean(L, global_fp->exfunc->is_editing(global_editp));
    } else {
        lua_pushnil(L);
    }
    return 1;
}

//---------------------------------------------------------------------
// [aviutl]ݕۑׂ
// ߂lFۑȂtrueiׂȂƂnilj
//---------------------------------------------------------------------
int call_is_saving(lua_State* L)
{
    if (global_fp && global_editp) {
        lua_pushboolean(L, global_fp->exfunc->is_saving(global_editp));
    } else {
        lua_pushnil(L);
    }
    return 1;
}

//---------------------------------------------------------------------
// [aviutl]ۂɕۑt[ׂ
// Ft[ԍ
// ߂lFۑȂtrueiׂȂƂnilj
//---------------------------------------------------------------------
int call_is_saveframe(lua_State* L)
{
    if (global_fp && global_editp) {
        int f = luaL_checkinteger(L, 1);
        lua_pushboolean(L, global_fp->exfunc->is_saveframe(global_editp, f));
    } else {
        lua_pushnil(L);
    }
    return 1;
}

//---------------------------------------------------------------------
// [aviutl]L[t[ׂ(*̕)
// Ft[ԍ
// ߂lFL[t[ȂtrueiׂȂƂnilj
//---------------------------------------------------------------------
int call_is_keyframe_input(lua_State* L)
{
    int f = luaL_checkinteger(L, 1);
    if (global_fp && global_editp) {
        BOOL b = global_fp->exfunc->is_keyframe(global_editp, f);
        lua_pushboolean(L, b);
    } else {
        lua_pushnil(L);
    }
    return 1;
}

//---------------------------------------------------------------------
// [aviutl]ҏWtO𒲂ׂ3Zbg
// EL[t[[key]ׂ
// E}[Nt[[mark]ׂ
// EԈDt[[del]ׂ
//
// Ft[ԍ
// ߂lFtOĂtrueiׂȂƂnilj
//---------------------------------------------------------------------
int check_editflag(lua_State* L, int mask)
{
    if (global_fp && global_editp) {
        int f = luaL_checkinteger(L, 1);
        FRAME_STATUS fsp;
        global_fp->exfunc->get_frame_status(global_editp, f, &fsp);

        BOOL b = !!(fsp.edit_flag & mask);

        lua_pushboolean(L, b);
    } else {
        lua_pushnil(L);
    }
    return 1;
}

int call_is_editflag_keyframe(lua_State* L)
{
    return check_editflag(L, EDIT_FRAME_EDIT_FLAG_KEYFRAME);
}

int call_is_editflag_markframe(lua_State* L)
{
    return check_editflag(L, EDIT_FRAME_EDIT_FLAG_MARKFRAME);
}

int call_is_editflag_delframe(lua_State* L)
{
    return check_editflag(L, EDIT_FRAME_EDIT_FLAG_DELFRAME);
}

//---------------------------------------------------------------------
// [aviutl]wԂ
// ߂lFiׂȂƂnilj
//---------------------------------------------------------------------
int call_get_w(lua_State* L)
{
    if (global_fpip) {
        lua_pushnumber(L, global_fpip->w);
    } else {
        lua_pushnil(L);
    }
    return 1;
}

//---------------------------------------------------------------------
// [aviutl]hԂ
// ߂lFiׂȂƂnilj
//---------------------------------------------------------------------
int call_get_h(lua_State* L)
{
    if (global_fpip) {
        lua_pushnumber(L, global_fpip->h);
    } else {
        lua_pushnil(L);
    }
    return 1;
}

//---------------------------------------------------------------------
// [aviutl]max_wԂ
// ߂lFҏWłő摜TCỶiׂȂƂnilj
//---------------------------------------------------------------------
int call_get_max_w(lua_State* L)
{
    if (global_fpip) {
        lua_pushnumber(L, global_fpip->max_w);
    } else if (global_fp) {
        // global_fpip->max_wƂ͔ɒlႤ
        SYS_INFO si;
        global_fp->exfunc->get_sys_info(global_editp, &si);
        lua_pushnumber(L, si.max_w);
    } else {
        lua_pushnil(L);
    }
    return 1;
}

//---------------------------------------------------------------------
// [aviutl]max_hԂ
// ߂lFҏWłő摜TCY̍i擾łȂƂ0j
//---------------------------------------------------------------------
int call_get_max_h(lua_State* L)
{
    if (global_fpip) {
        lua_pushnumber(L, global_fpip->max_h);
    } else if (global_fp) {
        SYS_INFO si;
        // global_editpNULLł
        global_fp->exfunc->get_sys_info(global_editp, &si);
        lua_pushnumber(L, si.max_h);
    } else {
        lua_pushnil(L);
    }
    return 1;
}

//---------------------------------------------------------------------
// [aviutl]min_wԂ
// ߂lFҏWłŏ摜TCYiׂȂƂnilj
//---------------------------------------------------------------------
int call_get_min_w(lua_State* L)
{
    if (global_fp) {
        // global_editpNULLł
        SYS_INFO si;
        global_fp->exfunc->get_sys_info(global_editp, &si);
        lua_pushnumber(L, si.min_w);
    } else {
        lua_pushnil(L);
    }
    return 1;
}

//---------------------------------------------------------------------
// [aviutl]min_hԂ
// ߂lFҏWłŏ摜TCYiׂȂƂnilj
//---------------------------------------------------------------------
int call_get_min_h(lua_State* L)
{
    if (global_fp) {
        // global_editpNULLł
        SYS_INFO si;
        global_fp->exfunc->get_sys_info(global_editp, &si);
        lua_pushnumber(L, si.min_h);
    } else {
        lua_pushnil(L);
    }
    return 1;
}

//---------------------------------------------------------------------
// [aviutl]w, h, max_w, max_hԂ
// ߂l1Fw
// ߂l2Fh
// ߂l3Fmax_w
// ߂l4Fmax_h
// ꂼ꒲ׂȂꍇnil
//---------------------------------------------------------------------
int call_get_size(lua_State* L)
{
    if (global_fpip) {
        lua_pushnumber(L, global_fpip->w);
        lua_pushnumber(L, global_fpip->h);
        lua_pushnumber(L, global_fpip->max_w);
        lua_pushnumber(L, global_fpip->max_h);
        if (global_fp) {
            // global_editpNULLł
            SYS_INFO si;
            global_fp->exfunc->get_sys_info(global_editp, &si);
            lua_pushnumber(L, si.min_w);
            lua_pushnumber(L, si.min_h);
        } else {
            lua_pushnil(L);
            lua_pushnil(L);
        }
    } else if (global_fp) {
        lua_pushnil(L);
        lua_pushnil(L);
        // global_editpNULLł
        SYS_INFO si;
        global_fp->exfunc->get_sys_info(global_editp, &si);
        lua_pushnumber(L, si.max_w);
        lua_pushnumber(L, si.max_h);
        lua_pushnumber(L, si.min_w);
        lua_pushnumber(L, si.min_h);
    } else {
        lua_pushnil(L);
        lua_pushnil(L);
        lua_pushnil(L);
        lua_pushnil(L);
        lua_pushnil(L);
        lua_pushnil(L);
    }

    return 6;
}

//---------------------------------------------------------------------
// [aviutl]w̒lύX
// F
// ߂lFݒ肵l̂܂ܕԂiݒłȂnilj
//---------------------------------------------------------------------
int call_set_w(lua_State* L)
{
    if (global_fpip) {
        int w = luaL_checkinteger(L, 1);
        global_fpip->w = w;
        lua_pushnumber(L, w);
    } else {
        lua_pushnil(L);
    }
    return 1;
}

//---------------------------------------------------------------------
// [aviutl]h̒lύX
// F
//---------------------------------------------------------------------
int call_set_h(lua_State* L)
{
    if (global_fpip) {
        int h = luaL_checkinteger(L, 1);
        global_fpip->h = h;
        lua_pushnumber(L, h);
    } else {
        lua_pushnil(L);
    }
    return 1;
}

//---------------------------------------------------------------------
// [aviutl]w, h̒lύX
// 1:w
// 2:h
// ߂l1Fݒ肵w̒l̂܂ܕԂiݒłȂnilj
// ߂l2Fݒ肵h̒l̂܂ܕԂiݒłȂnilj
//---------------------------------------------------------------------
int call_set_size(lua_State* L)
{
    if (global_fpip) {
        int w = luaL_checkinteger(L, 1);
        int h = luaL_checkinteger(L, 2);
        global_fpip->w = w;
        global_fpip->h = h;
        lua_pushnumber(L, w);
        lua_pushnumber(L, h);
    } else {
        lua_pushnil(L);
        lua_pushnil(L);
    }
    return 2;
}

//---------------------------------------------------------------------
// [aviutl]ycp_edit擾
// ߂lF摜f[^̃|C^i擾łȂƂnilԂj
//---------------------------------------------------------------------
int call_get_ycp_edit(lua_State* L)
{
    if (global_fpip) {
        lua_pushlightuserdata(L, (void *)global_fpip->ycp_edit);
    } else {
        lua_pushnil(L);
    }
    return 1;
}

//---------------------------------------------------------------------
// [aviutl]ycp_temp擾
// ߂lFe|̈̃|C^i擾łȂƂnilԂj
//---------------------------------------------------------------------
int call_get_ycp_temp(lua_State* L)
{
    if (global_fpip) {
        lua_pushlightuserdata(L, (void *)global_fpip->ycp_temp);
    } else {
        lua_pushnil(L);
    }
    return 1;
}

//---------------------------------------------------------------------
// [aviutl]ycp_editycp_tempƂ̃|C^ւ
// ߂l1F摜f[^̃|C^iւłȂƂnilԂj
// ߂l2Fe|̈̃|C^iւłȂƂnilԂj
//---------------------------------------------------------------------
int call_swap(lua_State* L)
{
    if (global_fpip) {
        PIXEL_YC *ycp_swap    = global_fpip->ycp_edit;
        global_fpip->ycp_edit = global_fpip->ycp_temp;
        global_fpip->ycp_temp = ycp_swap;

        lua_pushlightuserdata(L, (void *)global_fpip->ycp_edit);
        lua_pushlightuserdata(L, (void *)global_fpip->ycp_temp);
    } else {
        lua_pushnil(L);
        lua_pushnil(L);
    }
    return 2;
}

//---------------------------------------------------------------------
// [aviutl]ݕҏWframeit[ԍjԂ
// ߂lFt[ԍi擾łȂƂnilj
//---------------------------------------------------------------------
int call_get_frame(lua_State* L)
{
    if (global_fpip) {
        lua_pushnumber(L, global_fpip->frame);
    } else {
        lua_pushnil(L);
    }
    return 1;
}

//---------------------------------------------------------------------
// [aviutl]frame_nȋ݂t[jԂ
// ߂lFt[i擾łȂƂnilj
//---------------------------------------------------------------------
int call_get_frame_n(lua_State* L)
{
    if (global_fpip) {
        int frame_n = global_fpip->frame_n;
        lua_pushnumber(L, frame_n);
    } else if (global_fp && global_editp) {
        int frame_n = global_fp->exfunc->get_frame_n(global_editp);
        lua_pushnumber(L, frame_n);
    } else {
        lua_pushnil(L);
    }
    return 1;
}

//---------------------------------------------------------------------
// [aviutl]org_wi̕jԂ
// ߂lFIWỉi擾łȂƂ0j
//---------------------------------------------------------------------
int call_get_org_w(lua_State* L)
{
    if (global_fpip) {
        lua_pushnumber(L, global_fpip->org_w);
    } else {
        lua_pushnil(L);
    }
    return 1;
}

//---------------------------------------------------------------------
// [aviutl]org_hi̍jԂ
// ߂lFIWi̍i擾łȂƂ0j
//---------------------------------------------------------------------
int call_get_org_h(lua_State* L)
{
    if (global_fpip) {
        lua_pushnumber(L, global_fpip->org_h);
    } else {
        lua_pushnil(L);
    }
    return 1;
}

//---------------------------------------------------------------------
// [aviutl]org_worg_hԂ
// ߂l1FIWỉ
// ߂l2FIWi̍
//---------------------------------------------------------------------
int call_get_org_size(lua_State* L)
{
    if (global_fpip) {
        lua_pushnumber(L, global_fpip->org_w);
        lua_pushnumber(L, global_fpip->org_h);
    } else {
        lua_pushnil(L);
        lua_pushnil(L);
    }
    return 2;
}

//---------------------------------------------------------------------
// [aviutl]t[ύX
// ߂lFݒ肳ꂽt[iݒłȂƂnilj
//---------------------------------------------------------------------
int call_set_frame_n(lua_State* L)
{
    if (global_fp && global_editp) {
        int f = lua_tointeger(L, 1);
        lua_pushnumber(L, global_fp->exfunc->set_frame_n(global_editp, f));
    } else {
        lua_pushnil(L);
    }
    return 1;
}

//---------------------------------------------------------------------
// [aviutl]aviutlW̃TCYs
// ycp    FTCỸf[^߂摜̈̃|C^
// w      FTCỶ
// h      FTCY̍
// ycp_srcF摜̃|C^iȗycpɂȂj
// sx     F摜TCYΏۗ̈捶x
// sy     F摜TCYΏۗ̈捶y
// sw     F摜TCYΏۗ̈扡
// sh     F摜TCYΏۗ̈捂
// ߂lFycp
//---------------------------------------------------------------------
int call_resize_yc(lua_State* L)
{
    int n = lua_gettop(L); // ̐
    if (global_fp && n > 1 && lua_islightuserdata(L, 1)) {
        int index = 1;
        PIXEL_YC *ycp = (PIXEL_YC *)lua_touserdata(L, index++);
        int w = luaL_checkinteger(L, index++);
        int h = luaL_checkinteger(L, index++);
        PIXEL_YC *ycp_src = NULL; // NULLycpƓɂȂ
        if (lua_type(L, index) == LUA_TLIGHTUSERDATA) {
            ycp_src = (PIXEL_YC *)lua_touserdata(L, index++);
        }
        int sx = luaL_checkinteger(L, index++);
        int sy = luaL_checkinteger(L, index++);
        int sw = luaL_checkinteger(L, index++);
        int sh = luaL_checkinteger(L, index++);

        global_fp->exfunc->resize_yc(ycp, w, h, ycp_src, sx, sy, sw, sh);
        lua_pushlightuserdata(L, ycp);
    } else {
        lua_pushnil(L);
    }
    return 1;
}

//---------------------------------------------------------------------
// aviutl.copy(ycp, [x=0, y=0,] ycp_src [, sx=0, sy=0, sw, sh] [, tr=0])
// aviutlẄ̗Rs[s
// ycp    Fo͐摜̈̃|C^
// x      Fo͐x
// y      Fo͐y
// ycp_srcF摜̃|C^
// sx     F摜̑Ώۗ̈捶x
// sy     F摜̑Ώۗ̈捶y
// sw     F摜̑Ώۗ̈扡
// sh     F摜̑Ώۗ̈捂
// tr     Fxi0`4096Aȗjdef. 0
//---------------------------------------------------------------------
int call_copy_yc(lua_State* L)
{
    int n = lua_gettop(L); // ̐
    if (global_fp && n >= 2 && lua_islightuserdata(L, 1)) {
        int max_w, max_h;
        if (global_fpip) {
            max_w = global_fpip->max_w;
            max_h = global_fpip->max_h;
        } else {
            SYS_INFO si;
            global_fp->exfunc->get_sys_info(global_editp, &si);
            max_w = si.max_w;
            max_h = si.max_h;
        }

        int index = 1;
        PIXEL_YC *ycp = (PIXEL_YC *)lua_touserdata(L, index++);
        int x = 0, y = 0;
        if (lua_type(L, index) == LUA_TNUMBER) {
            x = lua_tointeger(L, index++);
            y = luaL_checkinteger(L, index++);
        }
        if (!lua_islightuserdata(L, index)) {
            lua_pushnil(L);
            return 1;
        }
        PIXEL_YC *ycp_src = (PIXEL_YC *)lua_touserdata(L, index++);
        int sx = 0, sy = 0, sw = max_w, sh = max_h;
        if ((n - index + 1) > 1) {
            sx = luaL_checkinteger(L, index++);
            sy = luaL_checkinteger(L, index++);
            sw = luaL_checkinteger(L, index++);
            sh = luaL_checkinteger(L, index++);
        }
        int tr = 0;
        if (lua_isnumber(L, index))
            tr = lua_tointeger(L, index++);

        global_fp->exfunc->copy_yc(ycp, x, y, ycp_src, sx, sy, sw, sh, tr);
        lua_pushlightuserdata(L, ycp);
    } else {
        lua_pushnil(L);
    }
    return 1;
}

//---------------------------------------------------------------------
// aviutl.gdoverlay(ycp, [x=0, y=0,] gdStr [, sx=0, sy=0, sw, sh] [, tr=0])
// gdStr̗̈Rs[s
// ycp  Fo͐摜̈̃|C^
// x    Fo͐x
// y    Fo͐y
// gdStrF摜̃|C^
// sx   F摜̑Ώۗ̈捶x
// sy   F摜̑Ώۗ̈捶y
// sw   F摜̑Ώۗ̈扡
// sh   F摜̑Ώۗ̈捂
// tr   Fxi0`4096j
//---------------------------------------------------------------------
int aviutl_gdoverlay(lua_State* L)
{
    int n = lua_gettop(L); // ̐
    if (global_fp && n >= 2 && lua_islightuserdata(L, 1)) {
        int index = 1;
        // o͐
        PIXEL_YC *ycp = (PIXEL_YC *)lua_touserdata(L, index++);
        // o͈ʒuiȗj
        int dx = 0, dy = 0;
        if (lua_type(L, index) == LUA_TNUMBER) {
            dx = lua_tointeger(L, index++);
            dy = luaL_checkinteger(L, index++);
        }
        // 摜
        luaL_checktype(L, index, LUA_TSTRING);
        const unsigned char* ptr = (const unsigned char*)lua_tostring(L, index++);
        // ʌ̈iȗj
        int sx = 0, sy = 0, sw = 0, sh = 0;
        const bool defSrcRect = ((n - index + 1) < 2);
        if (!defSrcRect) {
            sx = luaL_checkinteger(L, index++);
            sy = luaL_checkinteger(L, index++);
            sw = luaL_checkinteger(L, index++);
            sh = luaL_checkinteger(L, index++);
        }
        // x
        int tr = 0;
        if (lua_isnumber(L, index))
            tr = lua_tointeger(L, index++);

        // x͈̔̓`FbN
        if (tr >= 4096) {
            lua_pushlightuserdata(L, ycp);
            return 1;
        } else if (tr < 0) {
            tr = 0;
        }

        // gd̓x128iKȂ̂ŁA
        // vZʂOɃe[uɊi[Ă
        int opacMap[256];
        for(int i = 0; i < 128; i++) {
            int opac = 255 - ((i << 1) | (i & 1));
            opacMap[i] = 4096 - ((4096 - tr) * opac / 255);
        }
        // Ô߂ɖgp̒l߂
        for(int i = 128; i < 256; i++)
            opacMap[i] = 0;

        // GDwb_i11oCgj
        if (ptr[0] != 255 || (ptr[1] != 254 && ptr[1] != 255)) {
            luaL_error(L, "gdoverlay: invalid gd image.");
        }
        bool trueColor = (ptr[1] == 254);
        ptr += 2;
        int width = *ptr++ << 8;
        width |= *ptr++;
        int height = *ptr++ << 8;
        height |= *ptr++;
        if ((!trueColor && *ptr) || (trueColor && !*ptr)) {
            luaL_error(L, "gdoverlay: inconsistent color type.");
        }
        ptr++;
        int pitch = width * (trueColor ? 4 : 1);
        int colorsTotal = 0;
        if (!trueColor) {
            colorsTotal = *ptr++ << 8;
            colorsTotal |= *ptr++;
        }
        int transparent = *ptr++ << 24;
        transparent |= *ptr++ << 16;
        transparent |= *ptr++ << 8;
        transparent |= *ptr++;
        struct { int r, g, b, a; } pal[256];
        if (!trueColor) for (int i = 0; i < 256; i++) {
            pal[i].r = *ptr++;
            pal[i].g = *ptr++;
            pal[i].b = *ptr++;
            pal[i].a = opacMap[*ptr++];
        }

        // NbsO`̂߂ɉ摜̍őTCY擾
        int max_w, max_h;
        if (global_fpip) {
            max_w = global_fpip->max_w;
            max_h = global_fpip->max_h;
        } else {
            SYS_INFO si;
            global_fp->exfunc->get_sys_info(global_editp, &si);
            max_w = si.max_w;
            max_h = si.max_h;
        }
        // 摜̑Ώۗ̈̃ftHglݒ
        if (defSrcRect) {
            sw = width;
            sh = height;
        }

        // ̈̃NbsO
        if (sx < 0) {
            sw += sx; dx -= sx; sx = 0;
        }
        if (sy < 0) {
            sh += sy; dy -= sy; sy = 0;
        }
        if (sx+sw >= width)
            sw = width - sx;
        if (sy+sh >= height)
            sh = height - sy;
        if (dx < 0) {
            sw += dx; sx -= dx; dx = 0;
        }
        if (dy < 0) {
            sh += dy; sy -= dy; dy = 0;
        }
        if (dx+sw >= max_w)
            sw = max_w - dx;
        if (dy+sh >= max_h)
            sh = max_h - dy;
        // `̈悪ȂΉ摜̂܂ܕԂ
        if (sw <= 0 || sh <= 0) {
            lua_pushlightuserdata(L, ycp);
            return 1;
        }

        PIXEL_YC yc;
        PIXEL pixel;
        #define YCBLEND(ycpix, opac, rv, gv, bv) \
            if ((opac) < 4096) { \
                pixel.r = (rv); \
                pixel.g = (gv); \
                pixel.b = (bv); \
                global_fp->exfunc->rgb2yc(&yc, &pixel, 1); \
                if ((opac) <= 0) { \
                    (ycpix)->y = yc.y; \
                    (ycpix)->cb = yc.cb; \
                    (ycpix)->cr = yc.cr; \
                } else { \
                    (ycpix)->y  = ((int)(ycpix)->y  * (opac) + yc.y  * (4096-(opac))) / 4096; \
                    (ycpix)->cb = ((int)(ycpix)->cb * (opac) + yc.cb * (4096-(opac))) / 4096; \
                    (ycpix)->cr = ((int)(ycpix)->cr * (opac) + yc.cr * (4096-(opac))) / 4096; \
                } \
            }

        const unsigned char* pix = (const unsigned char*)(&ptr[sy*pitch + (sx*(trueColor?4:1))]);
        int bytesToNextLine = pitch - (sw * (trueColor?4:1));
        if (trueColor)
            for (int y = dy; y < sh+dy && y < max_h; y++, pix += bytesToNextLine) {
                for (int x = dx; x < sw+dx && x < max_w; x++, pix += 4) {
                    PIXEL_YC *ycpix = &ycp[y * max_w + x];
                    YCBLEND(ycpix, opacMap[pix[0]], pix[1], pix[2], pix[3]);
                }
            }
        else
            for (int y = dy; y < sh+dy && y < max_h; y++, pix += bytesToNextLine) {
                for (int x = dx; x < sw+dx && x < max_w; x++, pix++) {
                    int a = pal[*pix].a, r = pal[*pix].r, g = pal[*pix].g, b = pal[*pix].b;
                    PIXEL_YC *ycpix = &ycp[y * max_w + x];
                    YCBLEND(ycpix, a, r, g, b);
                }
            }

        #undef YCBLEND

        lua_pushlightuserdata(L, ycp);
    } else {
        lua_pushnil(L);
    }
    return 1;
}

//---------------------------------------------------------------------
// [aviutl]aviutlWdraw_textgăeLXg`
// 1F`悷摜̈̃|C^
// 2F`悷鍶Wx
// 3F`悷鍶Wy
// 4FeLXg
// 
// --ȍ~KȂƂŏȗ--
// 
// 5F`FRGBri0`255jdef. 0
// 6F`FRGBgi0`255jdef. 0
// 7F`FRGBbi0`255jdef. 0
// 8Fxi0`4096jdef. 0
// 9F̖i"MS PSVbN"Ƃjdef. NULLiVXeɑIԁj
// 10F def. 0iVXeɌ߂j
// 11Fϕ def. 0iVXeɌ߂j
// 12Fpx1i悭킩Ȃj
// 13Fpx2i悭킩Ȃj
// 14F̋i0`1000j
// 15FtrueȂC^bN
// 16FtrueȂA_[XRA͂AȂ
// 17FtrueȂj͂AȂ
//---------------------------------------------------------------------
int call_draw_text(lua_State* L)
{
    int n = lua_gettop(L); // ̐
    if (global_fp && n >= 4 && lua_islightuserdata(L, 1) && lua_isstring(L, 4) ) {
        PIXEL_YC *ycp = (PIXEL_YC *)lua_touserdata(L, 1);
        int x         = lua_tointeger(L, 2);
        int y         = lua_tointeger(L, 3);
        LPSTR text    = (LPSTR)lua_tostring(L, 4);
        int r         = (n >=  5) ? lua_tointeger(L, 5) : 0;
        int g         = (n >=  6) ? lua_tointeger(L, 6) : 0;
        int b         = (n >=  7) ? lua_tointeger(L, 7) : 0;
        int tr        = (n >=  8) ? lua_tointeger(L, 8) : 0;
        LPCTSTR face  = (n >=  9) ? (LPCTSTR)lua_tostring(L, 9) : NULL;
        int h         = (n >= 10) ? lua_tointeger(L, 10) : 0;
        int w         = (n >= 11) ? lua_tointeger(L, 11) : 0;
        int angle1    = (n >= 12) ? lua_tointeger(L, 12) : 0;
        int angle2    = (n >= 13) ? lua_tointeger(L, 13) : 0;
        int weight    = (n >= 14) ? lua_tointeger(L, 14) : 0;
        BOOL italic   = (n >= 15) ? !!lua_toboolean(L, 15) : FALSE;
        BOOL under    = (n >= 16) ? !!lua_toboolean(L, 16) : FALSE;
        BOOL strike   = (n >= 17) ? !!lua_toboolean(L, 17) : FALSE;

        HFONT hfont = CreateFont(
            h,      //tHg
            w,      //
            angle1,  //eLXg̊px
            angle2,  //x[XCƂƂ̊px
            weight, //tHg̏dij
            italic, //C^bN
            under,  //A_[C
            strike, //ł
            SHIFTJIS_CHARSET, //Zbg
            OUT_DEFAULT_PRECIS, //o͐x
            CLIP_DEFAULT_PRECIS,//NbsOx
            PROOF_QUALITY, //o͕i
            FIXED_PITCH | FF_MODERN, //sb`ƃt@~[
            face); //̖ 
        global_fp->exfunc->draw_text(ycp, x, y, text, r, g, b, tr, hfont, NULL, NULL);
        if (hfont) DeleteObject(hfont);

        lua_pushlightuserdata(L, ycp);
    } else {
        lua_pushnil(L);
    }
    return 1;
}


//---------------------------------------------------------------------
// [aviutl]rgb2yc
// 1Fri0`255j
// 2Fgi0`255j
// 3Fbi0`255j
// ߂l1Fyi0`4096j
// ߂l2Fcbi-2048`2048j
// ߂l3Fcri-2048`2048j
// ϊłȂꍇnilԂ
//---------------------------------------------------------------------
int call_rgb2yc(lua_State* L)
{
    if (global_fp) {
        PIXEL_YC yc;
        PIXEL pixel;
        pixel.r = lua_tointeger(L, 1);
        pixel.g = lua_tointeger(L, 2);
        pixel.b = lua_tointeger(L, 3);
        global_fp->exfunc->rgb2yc(&yc, &pixel, 1);
        lua_pushnumber(L, yc.y);
        lua_pushnumber(L, yc.cb);
        lua_pushnumber(L, yc.cr);
    } else {
        lua_pushnil(L);
        lua_pushnil(L);
        lua_pushnil(L);
    }
    return 3;
}

//---------------------------------------------------------------------
// [aviutl]yc2rgb
// 1Fyi0`4096j
// 2Fcbi-2048`2048j
// 3Fcri-2048`2048j
// ߂l1Fri0`255j
// ߂l2Fgi0`255j
// ߂l3Fbi0`255j
// ϊłȂꍇnilԂ
//---------------------------------------------------------------------
int call_yc2rgb(lua_State* L)
{
    if (global_fp) {
        PIXEL_YC yc;
        PIXEL pixel;
        int index = 1;
        yc.y  = luaL_checkinteger(L, index++);
        yc.cb = luaL_checkinteger(L, index++);
        yc.cr = luaL_checkinteger(L, index++);
        global_fp->exfunc->yc2rgb(&pixel, &yc, 1);
        lua_pushnumber(L, pixel.r);
        lua_pushnumber(L, pixel.g);
        lua_pushnumber(L, pixel.b);
    } else {
        lua_pushnil(L);
        lua_pushnil(L);
        lua_pushnil(L);
    }
    return 3;
}

//---------------------------------------------------------------------
// [aviutl]gbNo[̒lԂ
// FgbNo[̔ԍ
// ߂lFgbNo[̒li擾łȂꍇnilj
//---------------------------------------------------------------------
int call_get_track(lua_State* L)
{
    int n = luaL_checkinteger(L, 1);
    if (global_fp && n < global_fp->track_n) {
        lua_pushnumber(L, global_fp->track[n]);
    } else {
        lua_pushnil(L);
    }
    return 1;
}

//---------------------------------------------------------------------
// [aviutl]`FbN{bNX̐^UԂ
// F`FbN{bNX̔ԍi擾łȂꍇnilj
//---------------------------------------------------------------------
int call_get_check(lua_State* L)
{
    int n = luaL_checkinteger(L, 1);
    if (global_fp && n < global_fp->check_n) {
        lua_pushboolean(L, !!global_fp->check[n]);
    } else {
        lua_pushnil(L);
    }
    return 1;
}

//---------------------------------------------------------------------
// [aviutl]get_ycp_filtering_cache_ex()̃LbVݒ
// FLbV閇
// ߂lFȂtrueiݒłȂƂnilj
//---------------------------------------------------------------------
int call_set_ycp_filtering_cache_size(lua_State* L)
{
    if (global_fp) {
        int d = luaL_checkinteger(L, 1);
        int max_w, max_h;
        if (global_fpip) {
            max_w = global_fpip->max_w;
            max_h = global_fpip->max_h;
        } else {
            SYS_INFO si;
            global_fp->exfunc->get_sys_info(global_editp, &si);
            max_w = si.max_w;
            max_h = si.max_h;
        }
        lua_pushboolean(L, global_fp->exfunc->set_ycp_filtering_cache_size(global_fp, max_w, max_h, d, NULL));
    } else {
        lua_pushnil(L);
    }
    return 1;
}

//---------------------------------------------------------------------
// [aviutl]get_ycp_filtering_cache_ex() wt[LbV
// ̃tB^O܂ł̃tB^̂̂
// FLbVt[ԍ
// ߂lFLbV摜f[^ւ̃|C^
//---------------------------------------------------------------------
int call_get_ycp_filtering_cache_ex(lua_State* L)
{
    int f = luaL_checkinteger(L, 1);
    if (global_fp && global_editp) {
        PIXEL_YC *chache = global_fp->exfunc->get_ycp_filtering_cache_ex(global_fp, global_editp, f, NULL, NULL);
        lua_pushlightuserdata(L, chache);
    } else {
        lua_pushnil(L);
    }
    return 1;
}

//---------------------------------------------------------------------
// [aviutl]̃t[摜f[^̈쐬
// ߂lF摜̈̃|C^Ԃ
//---------------------------------------------------------------------
int call_create_yc(lua_State* L)
{
    if (global_fp) {
        PIXEL_YC *ycp = global_fp->exfunc->create_yc();
        lua_pushlightuserdata(L, ycp);
    } else {
        lua_pushnil(L);
    }
    return 1;
}

//---------------------------------------------------------------------
// [aviutl]create_ycŊmۂ̈폜
// Fcreate_ycō쐬摜̈̃|C^
//---------------------------------------------------------------------
int call_delete_yc(lua_State* L)
{
    int n = lua_gettop(L); // ̐
    if (global_fp && n >= 1 && lua_islightuserdata(L, 1)) {
        global_fp->exfunc->delete_yc( (PIXEL_YC *)lua_touserdata(L, 1) );
        lua_pushlightuserdata(L, NULL);
    } else {
        lua_pushnil(L);
    }
    return 1;
}

//---------------------------------------------------------------------
// [aviutl]I͈͂̊Jnt[ƏIt[Ԃ
// ߂l1FJn
// ߂l2FI
//---------------------------------------------------------------------
int call_get_select_frame(lua_State* L)
{
    if (global_fp && global_editp) {
        int st, ed;
        global_fp->exfunc->get_select_frame(global_editp, &st, &ed);
        lua_pushnumber(L, st);
        lua_pushnumber(L, ed);
    } else {
        lua_pushnil(L);
        lua_pushnil(L);
    }
    return 2;
}

//---------------------------------------------------------------------
// [aviutl]I͈͂̊Jnt[ƏIt[ݒ肷
// 1FJn
// 2FI
// ߂l1FȂtrue
//---------------------------------------------------------------------
int call_set_select_frame(lua_State* L)
{
    if (global_fp && global_editp) {
        int st = luaL_checkinteger(L, 1);
        int ed = luaL_checkinteger(L, 2);
        lua_pushboolean(L, global_fp->exfunc->set_select_frame(global_editp, st, ed));
    } else {
        lua_pushnil(L);
    }
    return 1;
}

//---------------------------------------------------------------------
// [aviutl]bmpǂݍ
// 1 : 摜ǂݍރt[摜ւ̃|C^ 
// 2 : BMP̖O
// ߂l1FȂTRUE
// ߂l2Fw
// ߂l3Fh
//---------------------------------------------------------------------
int call_load_image(lua_State* L)
{
    int n = lua_gettop(L); // ̐
    if (global_fp && n >= 2 && lua_islightuserdata(L, 1) && lua_isstring(L, 2)) {
        int w, h;
        PIXEL_YC *ycp = (PIXEL_YC *)lua_touserdata(L, 1);
        LPSTR filename = (LPSTR)lua_tostring(L, 2);
        lua_pushboolean(L, global_fp->exfunc->load_image( ycp, filename, &w, &h, NULL));
        lua_pushnumber(L, w);
        lua_pushnumber(L, h);
    } else {
        lua_pushnil(L);
        lua_pushnil(L);
        lua_pushnil(L);
    }
    return 3;
}

//---------------------------------------------------------------------
// [aviutl]wW(Y, Cb, Cr)擾
// 1Ft[摜̃|C^ 
// 2Fx
// 3Fy
// ߂l1FY
// ߂l2FCb
// ߂l3FCr
//---------------------------------------------------------------------
int call_get_pixel_yc(lua_State* L)
{
    int n = lua_gettop(L); // ̐
    if (global_fp && n >= 1 && lua_islightuserdata(L, 1)) {
        int max_w, max_h;
        if (global_fpip) {
            max_w = global_fpip->max_w;
            max_h = global_fpip->max_h;
        } else {
            SYS_INFO si;
            global_fp->exfunc->get_sys_info(global_editp, &si);
            max_w = si.max_w;
            max_h = si.max_h;
        }

        PIXEL_YC *ycp = (PIXEL_YC *)lua_touserdata(L, 1);
        int x = lua_tointeger(L, 2);
        int y = lua_tointeger(L, 3);

        if (x >= 0 && x < max_w && y >= 0 && y < max_h) {
            ycp += y * max_w + x;
            lua_pushnumber(L, ycp->y);
            lua_pushnumber(L, ycp->cb);
            lua_pushnumber(L, ycp->cr);
        } else {
            lua_pushnumber(L, 0);
            lua_pushnumber(L, 0);
            lua_pushnumber(L, 0);
        }
    } else {
        lua_pushnil(L);
        lua_pushnil(L);
        lua_pushnil(L);
    }
    return 3;
}

//---------------------------------------------------------------------
// [aviutl]wW(Y, Cb, Cr)ݒ
// 1Ft[摜̃|C^ 
// 2Fx
// 3Fy
// 4FY
// 5FCb
// 6FCr
// 7Ftrixjȗ
//---------------------------------------------------------------------
int call_set_pixel_yc(lua_State* L)
{
    int n = lua_gettop(L); // ̐
    if (global_fp && n >= 1 && lua_islightuserdata(L, 1)) {
        int max_w, max_h;
        if (global_fpip) {
            max_w = global_fpip->max_w;
            max_h = global_fpip->max_h;
        } else {
            SYS_INFO si;
            global_fp->exfunc->get_sys_info(global_editp, &si);
            max_w = si.max_w;
            max_h = si.max_h;
        }

        int index = 1;
        PIXEL_YC *ycp = (PIXEL_YC *)lua_touserdata(L, index++);
        int x = luaL_checkinteger(L, index++);
        int y = luaL_checkinteger(L, index++);
        int Y = luaL_checkinteger(L, index++);
        int Cb = luaL_checkinteger(L, index++);
        int Cr = luaL_checkinteger(L, index++);
        int tr = (lua_type(L, index) == LUA_TNUMBER) ? lua_tointeger(L, index++) : 0;
        lua_pushlightuserdata(L, ycp); // ߂l

        //if (x >= 0 && x < max_w && y >= 0 && y < max_h) {
        if ((unsigned int)x < (unsigned int)max_w && (unsigned int)y < (unsigned int)max_h) {
            ycp += y * max_w + x;
            if (tr <= 0) {
                ycp->y  = Y;
                ycp->cb = Cb;
                ycp->cr = Cr;
            } else if (tr < 4096) {
                ycp->y  = ((int)ycp->y  * tr + Y  * (4096-tr)) / 4096;
                ycp->cb = ((int)ycp->cb * tr + Cb * (4096-tr)) / 4096;
                ycp->cr = ((int)ycp->cr * tr + Cr * (4096-tr)) / 4096;
            }
        }
    } else {
        lua_pushnil(L);
    }
    return 1;
}

//---------------------------------------------------------------------
// [aviutl]`h
// 1Ft[摜̃|C^ 
// 2Fx1
// 3Fy1
// 4Fx2
// 5Fy2
// 6FY
// 7FCb
// 8FCr
// 9Ftrixj ȗ
//---------------------------------------------------------------------
int call_box(lua_State* L)
{
    int n = lua_gettop(L); // ̐
    if (global_fp && n >= 1 && lua_islightuserdata(L, 1)) {
        int max_w, max_h;
        if (global_fpip) {
            max_w = global_fpip->max_w;
            max_h = global_fpip->max_h;
        } else {
            SYS_INFO si;
            global_fp->exfunc->get_sys_info(global_editp, &si);
            max_w = si.max_w;
            max_h = si.max_h;
        }

        int index = 1;
        PIXEL_YC *ycp = (PIXEL_YC *)lua_touserdata(L, index++);
        int x1 = luaL_checkinteger(L, index++);
        int y1 = luaL_checkinteger(L, index++);
        int x2 = luaL_checkinteger(L, index++);
        int y2 = luaL_checkinteger(L, index++);
        int Y  = luaL_checkinteger(L, index++);
        int Cb = luaL_checkinteger(L, index++);
        int Cr = luaL_checkinteger(L, index++);
        int tr = (n >= index && lua_isnumber(L, index))  ? lua_tointeger(L, index++) : 0;
        lua_pushlightuserdata(L, ycp); // ߂l

        // x2>x1, y2>y1ɂȂ悤swap
        if (x1>x2) {int t=x1; x1=x2; x2=t;}
        if (y1>y2) {int t=y1; y1=y2; y2=t;}

        my_box(ycp, x1,y1, (x2-x1+1), (y2-y1+1), Y,Cb,Cr, tr, max_w, max_h);
    } else {
        lua_pushnil(L);
    }
    return 1;
}

//---------------------------------------------------------------------
// [aviutl]`͈͂K]ilK|W]j
// 1Ft[摜̃|C^ 
// 2Fx1
// 3Fy1
// 4Fx2
// 5Fy2
//---------------------------------------------------------------------
int call_invert(lua_State* L)
{
    int n = lua_gettop(L); // ̐
    if (global_fp && n >= 1 && lua_islightuserdata(L, 1)) {
        int max_w, max_h;
        if (global_fpip) {
            max_w = global_fpip->max_w;
            max_h = global_fpip->max_h;
        } else {
            SYS_INFO si;
            global_fp->exfunc->get_sys_info(global_editp, &si);
            max_w = si.max_w;
            max_h = si.max_h;
        }

        int index = 1;
        PIXEL_YC *ycp = (PIXEL_YC *)lua_touserdata(L, index++);
        int x1 = luaL_checkinteger(L, index++);
        int y1 = luaL_checkinteger(L, index++);
        int x2 = luaL_checkinteger(L, index++);
        int y2 = luaL_checkinteger(L, index++);
        lua_pushlightuserdata(L, ycp); // ߂l

        // x2>x1, y2>y1ɂȂ悤swap
        if (x1>x2) {int t=x1; x1=x2; x2=t;}
        if (y1>y2) {int t=y1; y1=y2; y2=t;}

        my_invert(ycp, x1,y1, (x2-x1+1), (y2-y1+1), max_w, max_h);
    } else {
        lua_pushnil(L); // ߂l
    }
    return 1;
}

//---------------------------------------------------------------------
// [aviutl]`͈͂PFʂ̏
// 1Ft[摜̃|C^ 
// 2Fx1
// 3Fy1
// 4Fx2
// 5Fy2
// 6FCb  def.0
// 7FCr  def.0
//---------------------------------------------------------------------
int call_monochroma(lua_State* L)
{
    int n = lua_gettop(L); // ̐
    if (global_fp && n >= 1 && lua_islightuserdata(L, 1)) {
        int max_w, max_h;
        if (global_fpip) {
            max_w = global_fpip->max_w;
            max_h = global_fpip->max_h;
        } else {
            SYS_INFO si;
            global_fp->exfunc->get_sys_info(global_editp, &si);
            max_w = si.max_w;
            max_h = si.max_h;
        }

        int index = 1;
        PIXEL_YC *ycp = (PIXEL_YC *)lua_touserdata(L, index++);
        int x1 = luaL_checkinteger(L, index++);
        int y1 = luaL_checkinteger(L, index++);
        int x2 = luaL_checkinteger(L, index++);
        int y2 = luaL_checkinteger(L, index++);
        // FiftHgƔj
        int Cb = 0, Cr = 0;
        if (lua_type(L, index) == LUA_TNUMBER) {
            Cb = lua_tointeger(L, index++);
            Cr = luaL_checkinteger(L, index++);
        }
        lua_pushlightuserdata(L, ycp); // ߂l

        // x2>x1, y2>y1ɂȂ悤swap
        if (x1>x2) {int t=x1; x1=x2; x2=t;}
        if (y1>y2) {int t=y1; y1=y2; y2=t;}

        my_monochroma(ycp, x1,y1, (x2-x1+1), (y2-y1+1), Cb,Cr, max_w, max_h);
    } else {
        lua_pushnil(L);
    }
    return 1;
}

//---------------------------------------------------------------------
// [aviutl]`͈͂UCNɂ
// 1Ft[摜̃|C^ 
// 2Fx1
// 3Fy1
// 4Fx2
// 5Fy2
// 6Fbw
// 7Fbh
// 8Fstrict   def. false
//---------------------------------------------------------------------
int call_mosaic(lua_State* L)
{
    int n = lua_gettop(L); // ̐
    if (global_fp && n >= 1 && lua_islightuserdata(L, 1)) {
        int max_w, max_h;
        if (global_fpip) {
            max_w = global_fpip->max_w;
            max_h = global_fpip->max_h;
        } else {
            SYS_INFO si;
            global_fp->exfunc->get_sys_info(global_editp, &si);
            max_w = si.max_w;
            max_h = si.max_h;
        }

        int index = 1;
        PIXEL_YC *ycp = (PIXEL_YC *)lua_touserdata(L, index++);
        int x1 = luaL_checkinteger(L, index++);
        int y1 = luaL_checkinteger(L, index++);
        int x2 = luaL_checkinteger(L, index++);
        int y2 = luaL_checkinteger(L, index++);
        int bw = luaL_checkinteger(L, index++);
        int bh = luaL_checkinteger(L, index++);
        BOOL strict = (lua_type(L, index) == LUA_TBOOLEAN) ? !!lua_toboolean(L, index++) : FALSE; // ftHgł͌vZȂ
        lua_pushlightuserdata(L, ycp); // ߂l

        // x2>x1, y2>y1ɂȂ悤swap
        if (x1>x2) {int t=x1; x1=x2; x2=t;}
        if (y1>y2) {int t=y1; y1=y2; y2=t;}

        my_mosaic(ycp, x1, y1, (x2-x1+1), (y2-y1+1), bw, bh,  max_w, max_h, strict);
    } else {
        lua_pushnil(L);
    }
    return 1;
}

//---------------------------------------------------------------------
// [aviutl](Y, Cb, Cr)
// 1Ft[摜̃|C^ 
// 2Fx1
// 3Fy1
// 4Fx2
// 5Fy2
// 6FY
// 7FCb
// 8FCr
// 9Ftrixj ȗ
// 10Fflag ȗ
//---------------------------------------------------------------------
int call_line(lua_State* L)
{
    int n = lua_gettop(L); // ̐
    if (global_fp && n >= 1 && lua_islightuserdata(L, 1)) {
        int max_w, max_h;
        if (global_fpip) {
            max_w = global_fpip->max_w;
            max_h = global_fpip->max_h;
        } else {
            SYS_INFO si;
            global_fp->exfunc->get_sys_info(global_editp, &si);
            max_w = si.max_w;
            max_h = si.max_h;
        }

        int index = 1;
        PIXEL_YC *ycp = (PIXEL_YC *)lua_touserdata(L, index++);
        int x1 = luaL_checkinteger(L, index++);
        int y1 = luaL_checkinteger(L, index++);
        int x2 = luaL_checkinteger(L, index++);
        int y2 = luaL_checkinteger(L, index++);
        int Y  = luaL_checkinteger(L, index++);
        int Cb = luaL_checkinteger(L, index++);
        int Cr = luaL_checkinteger(L, index++);
        int tr = (lua_type(L, index) == LUA_TNUMBER) ? lua_tointeger(L, index++) : 0;
        BOOL flag = (lua_type(L, index) == LUA_TBOOLEAN) ? !!lua_toboolean(L, index++) : FALSE;
        lua_pushlightuserdata(L, ycp); // ߂l
        my_line(ycp, x1, y1, x2, y2, Y, Cb, Cr, tr, max_w, max_h, flag);
    } else {
        lua_pushnil(L);
    }
    return 1;
}

//---------------------------------------------------------------------
// [aviutl]㉺]
// 1F摜̈̃|C^
// 2Fx
// 3Fy
// 4Fw
// 5Fh
//---------------------------------------------------------------------
int call_flip_vertical(lua_State* L)
{
    int n = lua_gettop(L); // ̐
    if (global_fp && n >= 1 && lua_islightuserdata(L, 1)) {
        PIXEL_YC *ycp = (PIXEL_YC *)lua_touserdata(L, 1);
        int x = lua_tointeger(L, 2);
        int y = lua_tointeger(L, 3);
        int w = lua_tointeger(L, 4);
        int h = lua_tointeger(L, 5);

        // max_wmax_h擾
        int max_w, max_h;
        if (global_fpip) {
            max_w = global_fpip->max_w;
            max_h = global_fpip->max_h;
        } else {
            SYS_INFO si;
            global_fp->exfunc->get_sys_info(global_editp, &si);
            max_w = si.max_w;
            max_h = si.max_h;
        }

        my_flip_vertical(ycp, x, y, w, h, max_w, max_h);
        lua_pushlightuserdata(L, ycp);
    } else {
        lua_pushnil(L);
    }
    return 1;
}

//---------------------------------------------------------------------
// [aviutl]E]
// 1F摜̈̃|C^
// 2Fx
// 3Fy
// 4Fw
// 5Fh
//---------------------------------------------------------------------
int call_flip_horizontal(lua_State* L)
{
    int n = lua_gettop(L); // ̐
    if (global_fp && n >= 1 && lua_islightuserdata(L, 1)) {
        PIXEL_YC *ycp = (PIXEL_YC *)lua_touserdata(L, 1);
        int x = lua_tointeger(L, 2);
        int y = lua_tointeger(L, 3);
        int w = lua_tointeger(L, 4);
        int h = lua_tointeger(L, 5);

        // max_wmax_h擾
        int max_w, max_h;
        if (global_fpip) {
            max_w = global_fpip->max_w;
            max_h = global_fpip->max_h;
        } else {
            SYS_INFO si;
            global_fp->exfunc->get_sys_info(global_editp, &si);
            max_w = si.max_w;
            max_h = si.max_h;
        }

        my_flip_horizontal(ycp, x, y, w, h, max_w, max_h);
        lua_pushlightuserdata(L, ycp);
    } else {
        lua_pushnil(L);
    }
    return 1;
}

//---------------------------------------------------------------------
// [O[o]AND
//---------------------------------------------------------------------
int call_AND(lua_State* L)
{
    int n = lua_gettop(L);
    int r = ~0;
    for (int i = 1; i <= n; i++)
        r &= luaL_checkinteger(L, i);
    lua_pushinteger(L, r);
    return 1;
}

//---------------------------------------------------------------------
// [O[o]OR
//---------------------------------------------------------------------
int call_OR(lua_State* L)
{
    int n = lua_gettop(L);
    int r = 0;
    for (int i = 1; i <= n; i++)
        r |= luaL_checkinteger(L, i);
    lua_pushinteger(L, r);
    return 1;
}

//---------------------------------------------------------------------
// [O[o]XOR
//---------------------------------------------------------------------
int call_XOR(lua_State* L)
{
    int n = lua_gettop(L);
    int r = 0;
    for (int i = 1; i <= n; i++)
        r ^= luaL_checkinteger(L, i);
    lua_pushinteger(L, r);
    return 1;
}

//---------------------------------------------------------------------
// [O[o]SHIFT
//---------------------------------------------------------------------
int call_SHIFT(lua_State* L)
{
    int num = luaL_checkinteger(L, 1);
    int shift = luaL_checkinteger(L, 2);
    if (shift < 0) {
        num <<= -shift;
    } else {
        num >>= shift;
    }
    lua_pushinteger(L, num);
    return 1;
}

//---------------------------------------------------------------------
// [O[o]BIT
//---------------------------------------------------------------------
int call_BIT(lua_State* L)
{
    int n = lua_gettop(L);
    int r = 0;
    for (int i = 1; i <= n; i++)
        r |= (1 << luaL_checkinteger(L, i));
    lua_pushinteger(L, r);
    return 1;
}
