//------------------------------------------------------------------------------
// 摜֐
//------------------------------------------------------------------------------
#include <windows.h>
#include <stdio.h>
#include <string.h>
#include "filter.h"

extern void print_edit( const char *str );

// 2̔zւ
inline void my_memswap( void *dst, void *src, size_t n )
{
    // gcc̎xNgC
    char *__restrict__ s1 = (char *)dst;
    char *__restrict__ s2 = (char *)src;
    for( ; n > 0; --n )
    {
        char t1 = *s1;
        char t2 = *s2;
        *s1++ = t2;
        *s2++ = t1;
    }

}

//------------------------------------------------------------------------------
// `hԂ
// boxƂfillƂrectƂĂ΂ĂB
// tr͓xi0`4096j
//------------------------------------------------------------------------------
void my_box( PIXEL_YC *ycp, int left, int top, int width, int height, int Y, int Cb, int Cr, int tr, int max_w, int max_h )
{
    // ls
    if( width <= 0 || height <= 0 || max_w <= 0 || max_h <= 0 ) return;

    // ͈͊OȂI
    if( left >= max_w || left+width <= 0 || top >= max_h || top+height <= 0 ) return;

    // ͈͊ONbsO
    if( left < 0 )
    {
        width += left;
        left = 0;
    }
    else if( left+width > max_w )
    {
        width = max_w - left;
    }
    if( top < 0 )
    {
        height += top;
        top = 0;
    }
    else if( top+height > max_h )
    {
        height = max_h - top;
    }

    // |C^
    ycp += top * max_w + left;

    // trixj̗Lŏꍇ
    if( tr <= 0 )
    {
        for( int y = 0; y < height; y++ )
        {
            for( int x = 0; x < width; x++ )
            {
                ycp->y  = Y;
                ycp->cb = Cb;
                ycp->cr = Cr;
                ycp++;
            }
            ycp += max_w - width;
        }
    }
    else if( tr < 4096 )
    {
        for( int y = 0; y < height; y++ )
        {
            for( int x = 0; x < width; x++ )
            {
                ycp->y  = ((int)ycp->y  * tr + Y  * (4096-tr)) / 4096;
                ycp->cb = ((int)ycp->cb * tr + Cb * (4096-tr)) / 4096;
                ycp->cr = ((int)ycp->cr * tr + Cr * (4096-tr)) / 4096;
                ycp++;
            }
            ycp += max_w - width;
        }
    }
}

//------------------------------------------------------------------------------
// iu[ñASYgpj
// tr͓xi0`4096j
// skipfirst͎n_(x1, y1)XLbv邩B(x1, y1)==(x2, y2)skipfirstƕ`ʂȂB
//------------------------------------------------------------------------------
void my_line( PIXEL_YC *ycp, int x1, int y1, int x2, int y2, int Y, int Cb, int Cr, int tr, int max_w, int max_h, BOOL skipfirst )
{
    if( max_w <= 0 || max_h <= 0 ) return;       // sȒl
    if( tr >= 4096 ) return;                     // 
    if( skipfirst && x1 == x2 && y1 == y2 ) return; // I_`

    // skipfirst̂Ƃ`ʂȂW
    const int no_x = x1;
    const int no_y = y1;

    int w = abs( x2 - x1 );
    int h = abs( y2 - y1 );

    // cEŒŏꍇ킯
    if( w >= h )
    {
        // x2 > x1 ɂȂ悤swap
        if( x1 > x2 )
        {
            int tx = x1; x1 = x2; x2 = tx;
            int ty = y1; y1 = y2; y2 = ty;
        }

        // x1`x2͈͊OȂI
        if( x1 >= max_w || x2 < 0 ) return;

        int dy = (y2 >= y1) ? 1 : -1; // y̐iޕ
        int e  = w;     // 덷Bew̕qƍlƕ₷il0.5j
        int ew = w * 2; // 2{x
        int eh = h * 2; // 2{x

        // x_st >=0 ɂȂ悤ɃNbsO
        int x_st = x1;
        if( x_st < 0 )
        {
            if( ew )
            {
                int a = e + eh * (-x_st);
                y1 += a / ew * dy;
                e = a % ew;
            }
            x_st = 0;
        }
        // MIN(x2, max_w-1)
        int x_ed = (x2 <= max_w-1) ? x2 : max_w-1;

        // y1`y2͈͊OȂI
        if( (y1<0 && y2<0) || (y1>=max_h && y2>=max_h) ) return;

        int y = y1;

        // c̃NbsO肽oO̔ɂȂ肻ȗ

        // ȍ~̏܂łI
        if( x_st > x_ed ) return;

        // [vŏ̓_
        // skipfirstȂ`悵ȂŃCNĝ
        int x = x_st;
        if( skipfirst && x == no_x && y == no_y )
        {
            x++;
            e += eh;
            if( e >= ew ) // 덷ꂽJグ
            {
                y += dy;
                e -= ew;
            }
        }

        // ̗Lłɏꍇ킯
        if( tr <= 0 ) // Ȃ
        {
            for( ; x < x_ed; x++ )
            {
                if( (unsigned)y < (unsigned)max_h ) // if (y >= 0 && y < max_h)
                {
                    int p = y * max_w + x;
                    ycp[p].y  = Y;
                    ycp[p].cb = Cb;
                    ycp[p].cr = Cr;
                }
                e += eh;
                if( e >= ew ) // 덷ꂽJグ
                {
                    y += dy;
                    e -= ew;
                }
            }
            // [vŌ̓_Bskipfirst̃|Cgł͂Ȃ̂Ȃ`
            if( x <= x_ed && (!skipfirst || (x != no_x || y != no_y)) )
            {
                if( (unsigned)y < (unsigned)max_h ) // if (y >= 0 && y < max_h)
                {
                    int p = y * max_w + x;
                    ycp[p].y  = Y;
                    ycp[p].cb = Cb;
                    ycp[p].cr = Cr;
                }
            }

        }
        else if( tr < 4096 ) // 
        {
            for( ; x < x_ed; x++ )
            {
                if( (unsigned)y < (unsigned)max_h ) // if (y >= 0 && y < max_h)
                {
                    int p = y * max_w + x;
                    ycp[p].y  = ((int)ycp[p].y  * tr + Y  * (4096-tr)) / 4096;
                    ycp[p].cb = ((int)ycp[p].cb * tr + Cb * (4096-tr)) / 4096;
                    ycp[p].cr = ((int)ycp[p].cr * tr + Cr * (4096-tr)) / 4096;
                }
                e += eh;
                if( e >= ew ) // 덷ꂽJグ
                {
                    y += dy;
                    e -= ew;
                }
            }
            // [vŌ̓_Bskipfirst̃|Cgł͂Ȃ̂Ȃ`
            if( x <= x_ed && (!skipfirst || (x != no_x || y != no_y)) )
            {
                if( (unsigned)y < (unsigned)max_h ) // if (y >= 0 && y < max_h)
                {
                    int p = y * max_w + x;
                    ycp[p].y  = ((int)ycp[p].y  * tr + Y  * (4096-tr)) / 4096;
                    ycp[p].cb = ((int)ycp[p].cb * tr + Cb * (4096-tr)) / 4096;
                    ycp[p].cr = ((int)ycp[p].cr * tr + Cr * (4096-tr)) / 4096;
                }
            }
        }

    }
    else // c̕
    {
        // y2 > y1 ɂȂ悤swap
        if( y1 > y2 )
        {
            int tx = x1; x1 = x2; x2 = tx;
            int ty = y1; y1 = y2; y2 = ty;
        }

        // y1`y2͈͊OȂI
        if( y1 >= max_h || y2 < 0 ) return;

        int dx = (x2 >= x1) ? 1 : -1; // x̐iޕ
        int e  = h;     // 덷Beh̕qƍlƕ₷il0.5j
        int ew = w * 2; // 2{x
        int eh = h * 2; // 2{x

        // y_st >= 0 ɂȂ悤ɃNbsO
        int y_st = y1;
        if( y_st < 0 )
        {
            if( eh )
            {
                int a = e + ew * (-y_st);
                x1 += a / eh * dx;
                e = a % eh;
            }
            y_st = 0;
        }
        // MIN(y2, max_h-1)
        int y_ed = (y2 <= max_h-1) ? y2 : max_h-1;

        // x1`x2͈͊OȂI
        if( (x1<0 && x2<0) ||  (x1>=max_h && x2>=max_h) ) return;

        int x = x1;

        // ̃NbsO肽oO̔ɂȂ肻ȗ

        // ȍ~̏܂łI
        if( y_st > y_ed ) return;

        // [vŏ̓_
        // b_end==FALSEŏI_Ȃ`悵ȂŃCNĝ
        int y = y_st;
        if( skipfirst && x == no_x && y == no_y )
        {
            y++;
            e += ew;
            if( e >= eh ) // 덷ꂽJグ
            {
                x += dx;
                e -= eh;
            }
        }

        // ̗Lłɏꍇ킯
        if( tr <= 0 ) // Ȃ
        {
            for( ; y < y_ed; y++ )
            {
                if( (unsigned)x < (unsigned)max_w ) //if (x >= 0 && x < max_w)
                {
                    int p = y * max_w + x;
                    ycp[p].y  = Y;
                    ycp[p].cb = Cb;
                    ycp[p].cr = Cr;
                }
                e += ew;
                if( e >= eh ) // 덷ꂽJグ
                {
                    x += dx;
                    e -= eh;
                }
            }
            // [vŌ̓_Bskipfirst̃|CgłȂ̂Ȃ`
            if( y <= y_ed && (!skipfirst || (x != no_x || y != no_y)) )
            {
                if( (unsigned)x < (unsigned)max_w ) //if (x >= 0 && x < max_w) {
                {
                    int p = y * max_w + x;
                    ycp[p].y  = Y;
                    ycp[p].cb = Cb;
                    ycp[p].cr = Cr;
                }
            }
        }
        else if (tr < 4096) // 
        {
            for( ; y <= y_ed; y++ )
            {
                if( (unsigned)x < (unsigned)max_w ) //if (x >= 0 && x < max_w)
                {
                    int p = y * max_w + x;
                    ycp[p].y  = ((int)ycp[p].y  * tr + Y  * (4096-tr)) / 4096;
                    ycp[p].cb = ((int)ycp[p].cb * tr + Cb * (4096-tr)) / 4096;
                    ycp[p].cr = ((int)ycp[p].cr * tr + Cr * (4096-tr)) / 4096;
                }
                e += ew;
                if( e >= eh )// 덷ꂽJグ
                {
                    x += dx;
                    e -= eh;
                }
            }
            // [vŌ̓_Bskipfirst̃|CgłȂ̂Ȃ`
            if( y <= y_ed && (!skipfirst || (x != no_x || y != no_y)) )
            {
                if( (unsigned)x < (unsigned)max_w )//if (x >= 0 && x < max_w)
                {
                    int p = y * max_w + x;
                    ycp[p].y  = ((int)ycp[p].y  * tr + Y  * (4096-tr)) / 4096;
                    ycp[p].cb = ((int)ycp[p].cb * tr + Cb * (4096-tr)) / 4096;
                    ycp[p].cr = ((int)ycp[p].cr * tr + Cr * (4096-tr)) / 4096;
                }
            }
        }
    }
}

//------------------------------------------------------------------------------
// ㉺]
//------------------------------------------------------------------------------
void my_flip_vertical(PIXEL_YC *ycp, int left, int top, int width, int height, int max_w, int max_h)
{
    // ls
    if( width <= 0 || height <= 0 || max_w <= 0 || max_h <= 0 ) return;

    // ͈͊OȂI
    if( left >= max_w || left+width <= 0 || top >= max_h || top+height <= 0 ) return;

    // ͈͊ONbsO
    if( left < 0 )
    {
        width += left;
        left = 0;
    }
    else if( left+width > max_w )
    {
        width = max_w - left;
    }
    if( top < 0 )
    {
        height += top;
        top = 0;
    }
    else if( top+height > max_h )
    {
        height = max_h - top;
    }

    // |C^
    PIXEL_YC *ycp_a = ycp +  top               * max_w + left;
    PIXEL_YC *ycp_b = ycp + (top + height - 1) * max_w + left;

    int y = height / 2; // y̓[vJE^
    while( --y >= 0 )
    {
        // CXbv
        my_memswap(ycp_a, ycp_b, width * sizeof(PIXEL_YC));
        ycp_a += max_w;
        ycp_b -= max_w;
    }
}

//------------------------------------------------------------------------------
// E]
//------------------------------------------------------------------------------
void my_flip_horizontal(PIXEL_YC *ycp, int left, int top, int width, int height, int max_w, int max_h)
{
    // ls
    if( width <= 0 || height <= 0 || max_w <= 0 || max_h <= 0 ) return;

    // ͈͊OȂI
    if( left >= max_w || left+width <= 0 || top >= max_h || top+height <= 0 ) return;

    // ͈͊ONbsO
    if( left < 0 )
    {
        width += left;
        left = 0;
    }
    else if( left+width > max_w )
    {
        width = max_w - left;
    }
    if( top < 0 )
    {
        height += top;
        top = 0;
    }
    else if( top+height > max_h )
    {
        height = max_h - top;
    }

    // |C^
    ycp += top * max_w + left;

    int y = height; // y̓[vJE^
    int w = width/2;
    while( --y >= 0 )
    {
        for( int x=0; x < w; x++ )
        {
            PIXEL_YC t = ycp[x];
            ycp[x] = ycp[width-x-1];
            ycp[width-x-1] = t;
        }
        ycp += max_w;
    }
}

//------------------------------------------------------------------------------
// Co[gilK|W]AK]j
//------------------------------------------------------------------------------
void my_invert( PIXEL_YC *ycp, int left, int top, int width, int height, int max_w, int max_h )
{
    // ls
    if( width <= 0 || height <= 0 || max_w <= 0 || max_h <= 0 ) return;

    // ͈͊OȂI
    if( left >= max_w || left+width <= 0 || top >= max_h || top+height <= 0 ) return;

    // ͈͊ONbsO
    if( left < 0 )
    {
        width += left;
        left = 0;
    }
    else if( left+width > max_w )
    {
        width = max_w - left;
    }
    if( top < 0 )
    {
        height += top;
        top = 0;
    }
    else if( top+height > max_h )
    {
        height = max_h - top;
    }

    // |C^
    ycp += top * max_w + left;

    // lK|W]
    for( int y = 0; y < height; y++ )
    {
        for( int x = 0; x < width; x++ )
        {
            ycp->y  = 4096 - ycp->y;
            ycp->cb = -ycp->cb;
            ycp->cr = -ycp->cr;
            ycp++;
        }
        ycp += max_w - width;
    }
}

//------------------------------------------------------------------------------
// PF
//------------------------------------------------------------------------------
void my_monochroma( PIXEL_YC *ycp, int left, int top, int width, int height, int Cb, int Cr, int max_w, int max_h )
{
    // ls
    if( width <= 0 || height <= 0 || max_w <= 0 || max_h <= 0 ) return;

    // ͈͊OȂI
    if( left >= max_w || left+width <= 0 || top >= max_h || top+height <= 0 ) return;

    // ͈͊ONbsO
    if( left < 0 )
    {
        width += left;
        left = 0;
    }
    else if( left+width > max_w )
    {
        width = max_w - left;
    }
    if( top < 0 )
    {
        height += top;
        top = 0;
    }
    else if( top+height > max_h )
    {
        height = max_h - top;
    }

    // |C^
    ycp += top * max_w + left;

    // 
    for( int y = 0; y < height; y++ )
    {
        for( int x = 0; x < width; x++ )
        {
            ycp->cb = Cb;
            ycp->cr = Cr;
            ycp++;
        }
        ycp += max_w - width;
    }
}

//------------------------------------------------------------------------------
// UCN
//------------------------------------------------------------------------------
void my_mosaic( PIXEL_YC *ycp, int left, int top, int width, int height, int bw, int bh, int max_w, int max_h, BOOL strict )
{
    // ls
    if( width <= 0 || height <= 0 || max_w <= 0 || max_h <= 0 ) return;

    // ͈͊OȂI
    if( left >= max_w || left+width <= 0 || top >= max_h || top+height <= 0 ) return;

    // 1ubÑTCYׂ
    if( bw <= 1 || bh <= 1 ) return;

    // [͈͊OȂ獷k߂悤
    if( left < 0 )
    {
        int old_left = left;
        left = left % bw;
        width -= left - old_left;
    }
    // [͈͊OȂ獷k߂悤
    if( top < 0 )
    {
        int old_top = top;
        top = top % bh;
        height -= top - old_top;
    }

    // E[NbsO
    int w = left + width;
    if( w > max_w )
    {
        w = max_w;
        width -= left + width - max_w;
    }
    // [NbsO
    int h = top + height;
    if( h > max_h )
    {
        h = max_h;
        height -= top + height - max_h;
    }

    int block_h = (height + bh - 1) / bh; // c̃ubN
    int block_w = (width + bw - 1) / bw; // ̃ubN

    for( int block_y = 0; block_y < block_h; block_y++ )
    {
        int y_start = top + bh *  block_y;
        int y_end   = top + bh * (block_y + 1);
        if( y_start < 0 ) y_start = 0; // NbsO
        if( y_end > h ) y_end = h; // NbsO
        int y_mid = y_start + (y_end - y_start) / 2;

        for( int block_x = 0; block_x < block_w; block_x++ )
        {
            int x_start = left + bw *  block_x;
            int x_end   = left + bw * (block_x + 1);
            if( x_start < 0 ) x_start = 0; // NbsO
            if( x_end > w ) x_end = w; // ENbsO
            int x_mid = x_start + (x_end - x_start) / 2;

            // hԂFvZ
            PIXEL_YC pix;
            if( strict )
            {
                // ɕς
                PIXEL_YC *ycp_dst = ycp + y_start * max_w;
                int yuv_y = 0, yuv_u = 0, yuv_v = 0;
                for( int y = y_start; y < y_end; y++ )
                {
                    for( int x = x_start; x < x_end; x++ )
                    {
                        yuv_y += ycp_dst[x].y;
                        yuv_u += ycp_dst[x].cb;
                        yuv_v += ycp_dst[x].cr;
                    }
                    ycp_dst += max_w;
                }
                int divsor = (y_end - y_start) * (x_end - x_start);
                if( divsor <= 0 ) divsor = 1;
                pix.y  = (yuv_y + divsor / 2                         ) / divsor; // ľܓ
                pix.cb = (yuv_u + divsor / 2 + (yuv_u >> 31) * divsor) / divsor; // }CiXȂ}CiX֎ľܓ
                pix.cr = (yuv_v + divsor / 2 + (yuv_v >> 31) * divsor) / divsor;

            }
            else
            {
                // t߂\lɂ
                pix = ycp[y_mid * max_w + x_mid];
            }

            // hԂ
            PIXEL_YC *ycp_dst = ycp + y_start * max_w;
            for( int y = y_start; y < y_end; y++ )
            {
                for( int x = x_start; x < x_end; x++ ) ycp_dst[x] = pix;
                ycp_dst += max_w;
            }
        }
    }

}
